<?php

declare(strict_types=1);

namespace Drupal\user_selected_formatter;

use Drupal\Core\Entity\FieldableEntityInterface;
use Drupal\Core\Field\FieldDefinitionInterface;
use Drupal\user_selected_formatter\Model\Preset;

/**
 * Interface for 'user_selected_formatter' service.
 */
interface UserSelectedFormatterServiceInterface {

  /**
   * Returns the user selected formatter preset used to format a given field.
   *
   * @param \Drupal\Core\Entity\ContentEntityInterface $entity
   *   The entity containing the field.
   * @param \Drupal\Core\Field\FieldDefinitionInterface $targetFieldDefinition
   *   The field name.
   *
   * @return \Drupal\user_selected_formatter\Model\Preset|null
   *   The user selected formatter preset.
   */
  public function getPresetByTargetField(FieldableEntityInterface $entity, FieldDefinitionInterface $targetFieldDefinition): ?Preset;

}
